#include "imagereader.h"

ImageReader::ImageReader()
{
	file = NULL;
}

ImageReader::~ImageReader()
{
	if(file != NULL)
	{
		delete file;
		file = NULL;
	}
}

void** ImageReader::open(string filepath, string action)
{
	file = ImageFile(filepath);
	if(!file->open(action)
	{
		return NULL;
	}
	return f->buffer();
}

void ImageReader::access(void** buffer, double *value, int index, char action, int band)
{
	if(index >= 0 && index <= MAX_FILE_SIZE)
	{
		if(action == 'r')
		{
			value = new double(buffer[index][band]);
		}
		else if(action == 'w')
		{
			buffer[index][band] = *value;
		}
	}
}

bool ImageReader::close(bool force)
{
	if(force)
	{
		return file->close(1);
	}
	else
	{
		return file->close(0);
	}
}
